package org.rcisoft.bus.wmsgoodsapply.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.rcisoft.bus.wmsgoodsapply.dto.AddWmsGoodsApplyDTO;
import org.rcisoft.bus.wmsgoodsapply.entity.WmsGoodsApply;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.model.CyPageInfo;

import java.util.List;

/**
 * Created by cy on 2024年5月29日 下午1:21:49.
 */
public interface WmsGoodsApplyService {

    /**
    * 保存 商品申请表
    * @param wmsGoodsApply
    * @return
    */
    CyPersistModel persist(WmsGoodsApply wmsGoodsApply);

    String appCode();

    /**
    * 删除 商品申请表
    * @param wmsGoodsApply
    * @return
    */
    CyPersistModel remove(WmsGoodsApply wmsGoodsApply);

    /**
    * 逻辑删除 商品申请表
    * @param wmsGoodsApply
    * @return
    */
    CyPersistModel removeLogical(WmsGoodsApply wmsGoodsApply);

    /**
    * 修改 商品申请表
    * @param wmsGoodsApply
    * @return
    */
    CyPersistModel merge(WmsGoodsApply wmsGoodsApply);

    /**
    * 根据id查询 商品申请表
    * @param id
    * @return
    */
    WmsGoodsApply findById(int id);

    /**
    * 分页查询 商品申请表
    * @param wmsGoodsApply
    * @return
    */
    IPage<WmsGoodsApply> findAllByPagination(CyPageInfo<WmsGoodsApply> paginationUtility,
              WmsGoodsApply wmsGoodsApply);

    IPage<WmsGoodsApply> OutfindAllByPagination(CyPageInfo<WmsGoodsApply> paginationUtility,
                                             WmsGoodsApply wmsGoodsApply);

    /**
    * 查询list 商品申请表
    * @param wmsGoodsApply
    * @return
    */
    List<WmsGoodsApply> findAll(WmsGoodsApply wmsGoodsApply);


    /**
    * 导出商品申请表
    * @return
    */
    List<WmsGoodsApply> export(WmsGoodsApply wmsGoodsApply);

    CyPersistModel batchPersist(AddWmsGoodsApplyDTO wmsGoodsApply);
    CyPersistModel batchOutPersist(AddWmsGoodsApplyDTO wmsGoodsApply);

    WmsGoodsApply findByIdOut(int id);
}
