package org.rcisoft.bus.wmsgoodsapply.dto;

import cn.afterturn.easypoi.excel.annotation.Excel;
import lombok.*;

@Data
@AllArgsConstructor
@NoArgsConstructor
@Setter
@Getter
public class ExportEntryDto {
    @Excel(name = "商品编码", orderNum = "0", width = 20)
    private String goodsCode;
    @Excel(name = "商品类型", orderNum = "1", width = 20)
    private String goodsType;
    @Excel(name = "颜色", orderNum = "2", width = 20)
    private String goodsArticleNumber;
    @Excel(name = "小类", orderNum = "3", width = 20)
    private String goodsSubclass;
    @Excel(name = "颜色", orderNum = "4", width = 20)
    private String goodsColour;
    @Excel(name = "规格", orderNum = "5", width = 20)
    private String goodsNorms;
    @Excel(name = "编码", orderNum = "6", width = 20)
    private String goodsSize;
    @Excel(name = "出入库状态", orderNum = "7", width = 20)
    private String ioType;
    @Excel(name = "数量", orderNum = "8", width = 20)
    private Integer goodsCounts;
    @Excel(name = "申请单号", orderNum = "9", width = 20)
    private String appCode;
    @Excel(name = "发货方", orderNum = "10", width = 20)
    private String shipper;
    @Excel(name = "发货方地址", orderNum = "11", width = 20)
    private String shipperAddress;
    @Excel(name = "发货方联系方式", orderNum = "12", width = 20)
    private Integer shipperPhone;
    @Excel(name = "复核状态", orderNum = "13", width = 20)
    private String goodsCheck;
    @Excel(name = "业务员 ", orderNum = "14", width = 20)
    private String salesman;
    @Excel(name = "制单员", orderNum = "15", width = 20)
    private String maker;

}
